/*  Copyright 2023 Dieter Holzhäuser  E-Mail: dieter.holzhauser@gmail.com
  
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published serbuf
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//Sketch for fun by testing reaction time, by playing music and 
//by calclating prime numbers, all at the same time

//note:   WPIN  ->  digitalWrite       RPIN  ->  digitalRead

#include <mtRTOS2407.h>

////////////////Hardware
//      LED      Output pin
#define YELLOW   10
#define BLUE     11
#define GREEN    12
//  LED_BUILTIN  13 

//      Pushbutton  Input pin   (14..21 _->  A0..A7)
#define BUTTON      19          //-> A5  

////////////////Task Definitions  ( 0 to 18 )
#define BLRED       0  
#define COMM        1  
#define REAC        2 
#define PLAY        3
#define PRIME       4
//////////////Semaphore Definitions ( 0 to 17 )

////////////////////Task BLRED     symmetrical flashing means signs of life
void blred1 () {
  WPIN(LED_BUILTIN , !RPIN( LED_BUILTIN ) ) ;  
  mtdelay (500, blred1); 
}

///////
void setup () {  
  pinMode  (LED_BUILTIN, OUTPUT); 
  pinMode  (YELLOW, OUTPUT);  
  pinMode  (BLUE, OUTPUT);  
  pinMode  (GREEN, OUTPUT); 
  pinMode  (BUTTON, INPUT_PULLUP);  //internal pullup used
          //Library inits
  initmt();                         //Init Multitasking Kernel  
  initserial (38400);               //use Serial.print (PR) only
          
  start (BLRED, blred1);  
  start (COMM, comm1);
  start (REAC, reac1);
  start (PRIME, prime1);
  
  runner ();                        //avoid loop()                                        
}
