

/////////////////Task PUSHBUTTON 
//If BUTTON is pressed one pulse of LED BLUE is generated and 
//cycle of LED YELLOW is paused or continued
//This is done by using semaphores

void pushbutton1 () {                  //reserved for inits
  mtcoop (pushbutton2);     
}
void pushbutton2 () {     
  mtpin (BUTTON, LOW, pushbutton3);    //waiting for push button to be pressed
}
void pushbutton3 () {   
  if (gettaskstate(BLYELLOW) == WAITING_S)
    signal (PAUSESEMA);                //continue task BLYELLOW
  else clearsema (PAUSESEMA);          //destroy PAUSESEMA to pause task BLYELLOW
///
  signal (SIGNALSEMA);                 //trigger task ONBLUE 
  mtpin (BUTTON, HIGH, pushbutton2);   //waiting for push button to be released
}

/////////////////Task ONBLUE creates one pulse of LED BLUE 
void onblue1 () {
  mtsema (SIGNALSEMA, onblue2);     
} 
void onblue2 () {
  WPIN (BLUE, HIGH ) ;  
  mtdelay (3000, onblue3);
} 
void onblue3 () {
  WPIN (BLUE, LOW) ;  
  mtcoop (onblue1);
}

///////////////Task BLYELLOW is a cycle of LED YELLOW
///////////////Cycle is paused or continued by PAUSESEMA
void blyellow1 () {
  mtsema (PAUSESEMA, blyellow2);
}
void blyellow2 () {
  signal (PAUSESEMA);              // set self continuing !immediate!
  WPIN(YELLOW, !RPIN(YELLOW) ) ;  
  mtdelay (1000, blyellow1); 
}

//                Semaphore EXCLSEMA ensures of mutual exclusion
/////////Task SHORTGREEN generates  short LED GREEN pulses
void shortgreen1 () {
  mtsema (EXCLSEMA, shortgreen2);
} 
void shortgreen2 () {
  WPIN (GREEN, HIGH ); 
  PR ((int) getruntask () );      //monitoring 
  mtdelay (100, shortgreen3);     
} 
void shortgreen3 () {    
  WPIN (GREEN, LOW ); 
  mtdelay (1000, shortgreen4); 
}
void shortgreen4 () {   
  signal (EXCLSEMA);     
  mtdelay ( rand() % 3000 , shortgreen1);  
}

/////////Task LONGGREEN generates long LED GREEN pulses  (equals Task SHORTGREEN)
void longgreen1 () {
  mtsema (EXCLSEMA, longgreen2);
} 
void longgreen2 () { 
  WPIN (GREEN, HIGH ); 
  PR ((int) getruntask () );      
  mtdelay (800, longgreen3);      
}
void longgreen3 () {    
  WPIN (GREEN, LOW ); 
  mtdelay (1000, longgreen4);
}
void longgreen4 () {   
  signal (EXCLSEMA);    
  mtdelay ( rand() % 3000 , longgreen1);            
}
