
/*  Copyright 2023 Dieter Holzhäuser  E-Mail: dieter.holzhauser@gmail.com
  
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published serbuf
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//                Sketch is a demo of mtRTOS semaphores

//note:   WPIN  <->  digitalWrite       RPIN  <->  digitalRead

#include <mtRTOS2407.h>

////////////////Hardware
//Output pins
#define YELLOW   10
#define BLUE     11
#define GREEN    12
//LED_BUILTIN    13 

//      Pushbutton  Input pin   (14..21 -> A0..A7)
#define BUTTON      19          //-> A5  

////////////////Task Definitions  ( 0 to 18)
#define BLRED          0  
#define PUSHBUTTON     1
#define ONBLUE         2
#define BLYELLOW       3
#define SHORTGREEN     4
#define LONGGREEN      5

//////////////Semaphore Definitions ( 0 to 17 )
#define EXCLSEMA       0 
#define SIGNALSEMA     1 
#define PAUSESEMA      2

///////////////Task BLRED   symmetrical flashing of LED_BUILTIN means signs of life
void blred1 () {
  WPIN(LED_BUILTIN , !RPIN( LED_BUILTIN ) ) ;  
  mtdelay (500, blred1); 
}

///////
void setup () {  
  pinMode  (LED_BUILTIN, OUTPUT); 
  pinMode  (YELLOW, OUTPUT);  
  pinMode  (BLUE, OUTPUT);  
  pinMode  (GREEN, OUTPUT); 
  pinMode  (BUTTON, INPUT_PULLUP);  //internal pullup used

  initmt();                         
  Serial.begin (38400);             

  start (BLRED, blred1);  
  start (LONGGREEN, longgreen1); 
  start (SHORTGREEN, shortgreen1);
  signal (EXCLSEMA);  
  start (ONBLUE, onblue1);
  start (BLYELLOW, blyellow1);
  start (PUSHBUTTON, pushbutton1);
      
  runner ();                                                      
}
