/*  Copyright 2023 Dieter Holzhäuser  E-Mail: dieter.holzhauser@gmail.com
  
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published serbuf
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

///////////////// Sketch is a demo of mtRTOS serial user input 

//note:   WPIN  ->  digitalWrite       RPIN  ->  digitalRead


#include <mtRTOS2407.h>

////////////////Hardware
//LED Output pins
#define YELLOW   10
#define BLUE     11
#define GREEN    12
//LED_BUILTIN    13 

//      Pushbutton  Input pin   (14..21 -> A0..A7)
#define BUTTON      19        // -> A5 

////////////////Task Definitions  ( 0 to 18)
#define BLRED          0  
#define BLYELLOW       1
#define BLBLUE         2
#define COMM           3

//////////////Semaphore Definitions ( 0 to 17 )


////////////////////Task BLRED    symmetrical flashing means signs of life
void blred1 () {
  WPIN(LED_BUILTIN , !RPIN( LED_BUILTIN ) ) ;  
  mtdelay (1000, blred1); 
}

void setup () {  
  pinMode  (LED_BUILTIN, OUTPUT); 
  pinMode  (YELLOW, OUTPUT);  
  pinMode  (BLUE, OUTPUT);  
  pinMode  (GREEN, OUTPUT); 
  pinMode  (BUTTON, INPUT_PULLUP);  //internal pullup used
                  //Library inits
  initmt();                         //Multitasking Kernel  
  initserial (38400);               
                        
  start (BLRED, blred1);  
  start (BLBLUE, blblue1);
  start (BLYELLOW, blyellow1);
  start (COMM, comm1);  
  
  runner ();                        //avoid loop()                                    
}
