
///Serial user input library interface:
//Semaphore  INPSEM   ->  serial user input has taken place
//extern char id      ->  ID:   0 (LF), 'a'to'z' , 'A'to'Z'
//extern char inum    ->  number of numeric data, inum == 0 means input of id only
//extern long lnum [MAXNUM]  ->  array of numeric data 

//     Serial user input format 
//  LF  or  id LF  or  id num (num) (num) (num) LF    (blank(s) as separator)
//      Format of num (digits 123 as example)
//  #  or  123  or  -123  or  1.23  or  -1.23   (# -> numeric equivalent of exeptions)


//////////Task COMM     Serial user input evaluation using library interface

//EEMEM adresses
#define EEyetime  0
#define EEperiod  EEyetime + sizeof (long)
#define EEratio   EEperiod + sizeof (long)


String b = "b ";
String y = "y ";
String s = "SET ";
String g = "GET ";
String pr = "period ms: ";
String yt = "yetime ms: ";
String rt = ", ratio: ";
String oor = "out of range";
String err = "num error";

void prt_bltime (char get) {          //print
  if (get) PR ( b + g + pr); else  PR ( b + s + pr);  
  PR ( period );
  PR (rt);
  PRln (ratio); 
}
void eebltime1 () { 
  mtsema (EESEM, eebltime2); 
}
void eebltime2 () { 
  eewrite ( &ratio, sizeof (long), EEratio, comm2); 
}

void do_bltime () {                       // ID 'b'
  if (inum == 2 ) {                       // set data
    if (lnum[0] >= 200 && lnum[0] <= 5000 
               &&  lnum[1] >= 10 && lnum[1] <= 90 ) {    //equals  0.1  and  0.9
      ratio = (float)lnum[1] / 100;          
      period = lnum[0];
      htime =  period * ratio;           
      ltime =  period - htime;
      prt_bltime (0);   
      eewrite ( &period, sizeof (long), EEperiod, eebltime1) ;  
      return;
    }
    else PRln (b + oor);               // out of range
  } 
  else if ( inum == 0)                //get data
         prt_bltime (1);      
       else PRln (b + err);
  mtcoop (comm2);
}
///////////////////////////////
void yestop () { 
  WPIN(YELLOW, HIGH); 
}

void do_yetime () {                 // ID  'y'
   if (inum) {
    if (lnum[0] == NONB) {         // #   stop/start       
      PR (y + s + "# "); 
      if (gettaskstate(BLYELLOW) == TERMINATED) {
        start (BLYELLOW, blyellow1);
        PRln ("start");
      }
      else {
        stop (BLYELLOW, yestop);
        PRln ("stop"); 
      }        
    }
    else  if (lnum[0] >= 10 && lnum[0] <= 5000 ) {    // set data
            yetime = lnum[0];
            PR (y + s + yt );           
            PRln (yetime);
            eewrite ( &yetime, sizeof (long), EEyetime, comm2) ;
            return;        
          }
          else PRln (y + oor);     // out of range
  } 
  else {                           //get data
    PR (y + g + yt);  
    PR ( yetime);
    if (gettaskstate(BLYELLOW) == TERMINATED) 
      PRln ( " #");
    else PRln (); 
  }         
  mtcoop (comm2); 
} 

void comm1 () {                // init task
  eeread ( EEyetime, sizeof (long), &yetime);   //load yetime from EEMEM
  eeread ( EEperiod, sizeof (long), &period); 
  eeread ( EEratio, sizeof (long), &ratio); 
  htime = period * ratio;   
  ltime = period - htime;   
  mtcoop (comm2);
}
void comm2 () { 
  mtsema (INPSEM, comm3);     // User input has taken place
}    
void comm3 () {                // evaluation of id
  if (id == 'i' ) {
    PR ("i idle: ");
    PRln ( getidle() );
  }
  else if (id == 'y' ) {
         mtcoop (do_yetime );
         return;
       }
       else if (id == 'b' ) {
              mtcoop (do_bltime );
              return;
            }
            else PRln ("Valid IDs: i idle, y yellow, b blue");   
  mtcoop (comm2);
}
